/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2021 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2021 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ CCPUeI/O ]
 *
 *	RHG
 *	  2003.05.28		BEEP ON̏ԂŃXe[gt@CǂݍłBEEP~
 *						܂ȂC
 *	  2003.08.12		Xs[JtȌYĂ̂C(`
 *	  2005.11.12		FM-8[hɃ^C}~悤ɕύX
 *	  2010.07.28		FM-8[hɂ$FD0FR/WBASIC ROM/RAM̑I
 *						悤ɕύX
 *	  2021.04.10		FM-7[hA$FD0BR/WBASIC ROM/RAM̑Ił
 *						悤ɕύX
 */

#include <string.h>
#include "xm7.h"
#include "mainetc.h"
#include "keyboard.h"
#include "opn.h"
#include "device.h"
#include "event.h"

/*
 *	O[o [N
 */
BOOL key_irq_flag;					/* L[{[h荞 v */
BOOL key_irq_mask;					/* L[{[h荞 }XN */
BOOL lp_irq_flag;					/* v^荞 v */
BOOL lp_irq_mask;					/* v^荞 }XN */
BOOL timer_irq_flag;				/* ^C}[荞 v */
BOOL timer_irq_mask;				/* ^C}[荞 }XN */

BOOL mfd_irq_flag;					/* FDC荞 tO */
BOOL mfd_irq_mask;					/* FDC荞 }XN */
BOOL txrdy_irq_flag;				/* TxRDY荞 tO */
BOOL txrdy_irq_mask;				/* TxRDY荞 }XN */
BOOL rxrdy_irq_flag;				/* RxRDY荞 tO */
BOOL rxrdy_irq_mask;				/* RxRDY荞 }XN */
BOOL syndet_irq_flag;				/* SYNDET荞 tO */
BOOL syndet_irq_mask;				/* SYNDET荞 }XN */
#ifdef MOUSE
BOOL ptm_irq_flag;					/* PTM荞 tO */
BOOL ptm_irq_mask;					/* PTM荞 }XN */
#endif
	
BOOL opn_irq_flag;					/* OPN荞 tO */
BOOL whg_irq_flag;					/* WHG荞 tO */
BOOL thg_irq_flag;					/* THG荞 tO */
#if XM7_VER >= 3
BOOL dma_irq_flag;					/* DMA荞 tO */
#endif
BOOL beep_flag;						/* BEEPtO */
BOOL speaker_flag;					/* Xs[JtO */
#if XM7_VER == 1
BYTE banksel_en;					/* oN؂芷Cl[utO */
BOOL keyport_en;					/* CKeyboard I/OCl[utO */
BOOL fm7irq_en;						/* FM-8[hFM-7 IRQCl[utO */
#endif
BOOL new7_bootpatch;				/* NEW7u[gpb` */

/*
 *	X^eBbN [N
 */
#if XM7_VER == 1 && defined(BUBBLE)
static int boot_mode_reset;			/* Zbg̃u[gROMoN */
#endif

/*
 *	vg^Cv錾
 */
static BOOL FASTCALL mainetc_event(void);	/* 2.03ms ^C}[Cxg */

/*
 *	CCPU I/O
 *	
 */
BOOL FASTCALL mainetc_init(void)
{
#if XM7_VER == 1
	/* FM-8[h̕W̓oN؂芷 */
	banksel_en = BANKSEL_DISABLE;

	/* L[I/O|[g */
	keyport_en = FALSE;

	/* FM-7[hIRQ */
	fm7irq_en = FALSE;
#ifdef BUBBLE
	boot_mode_reset = BOOT_BASIC;
#endif
#endif

	/* u[gROMpb` */
	new7_bootpatch = TRUE;

	return TRUE;
}

/*
 *	CCPU I/O
 *	N[Abv
 */
void FASTCALL mainetc_cleanup(void)
{
}

/*
 *	CCPU I/O
 *	Zbg
 */
void FASTCALL mainetc_reset(void)
{
	/* 荞݃tO */
	key_irq_flag = FALSE;
	key_irq_mask = TRUE;
	lp_irq_flag = FALSE;
	lp_irq_mask = TRUE;
	timer_irq_flag = FALSE;
	timer_irq_mask = TRUE;

	mfd_irq_flag = FALSE;
	mfd_irq_mask = TRUE;
	txrdy_irq_flag = FALSE;
	txrdy_irq_mask = TRUE;
	rxrdy_irq_flag = FALSE;
	rxrdy_irq_mask = TRUE;
	syndet_irq_flag = FALSE;
	syndet_irq_mask = TRUE;
#ifdef MOUSE
	ptm_irq_flag = FALSE;
	ptm_irq_mask = TRUE;
#endif

	opn_irq_flag = FALSE;
	whg_irq_flag = FALSE;
	thg_irq_flag = FALSE;
#if XM7_VER >= 3
	dma_irq_flag = FALSE;
#endif

	/* BEEPtO */
	beep_flag = FALSE;
	speaker_flag = FALSE;

#if XM7_VER == 1
	/* Cxgǉ(FM-8[h) */
	if ((fm_subtype != FMSUB_FM8) || fm7irq_en) {
		schedule_setevent(EVENT_MAINTIMER, 2034, mainetc_event);
	}
	else {
		schedule_delevent(EVENT_MAINTIMER);
	}
#else
	/* Cxgǉ */
	schedule_setevent(EVENT_MAINTIMER, 2034, mainetc_event);
#endif

	/* ʒm */
	beep_notify();

	/* Zbg̃u[g[hL */
#if XM7_VER == 1 && defined(BUBBLE)
	boot_mode_reset = boot_mode;
#endif
}

/*
 *	BEEPICxg
 */
BOOL FASTCALL mainetc_beep(void)
{
	/* BEEP~ */
	beep_flag = FALSE;

	/* ȃCxg폜́ATRUEɂ */
	schedule_delevent(EVENT_BEEP);

	/* ʒm */
	beep_notify();

	return TRUE;
}

/*
 *	^C}[荞݃Cxg
 */
static BOOL FASTCALL mainetc_event(void)
{
	/* 2.03msƂCLKŁAmask̔]DFFœ͂ */
	timer_irq_flag = !timer_irq_mask;
	maincpu_irq();

	/* CLK4.9152MHzȂ̂ŁA2.0345msPʂŔ */
	if (event[EVENT_MAINTIMER].reload == 2034) {
		schedule_setevent(EVENT_MAINTIMER, 2035, mainetc_event);
	}
	else {
		schedule_setevent(EVENT_MAINTIMER, 2034, mainetc_event);
	}

	return TRUE;
}

/*
 *	FDC荞
 *	(fdc.cR}hEُIAtH[XC^vgŌĂ΂)
 */
void FASTCALL mainetc_fdc(void)
{
#if XM7_VER == 1
	/* }XNĂ΁AȂ */
	if ((fm_subtype == FMSUB_FM8) || mfd_irq_mask) {
		return;
	}
#else
	/* }XNĂ΁AȂ */
	if (mfd_irq_mask) {
		return;
	}
#endif

	/* CCPUIRQ荞݂ */
	mfd_irq_flag = TRUE;

	/*  */
	maincpu_irq();
}

/*
 *	LP荞
 *	(tapelp.cv^f[^o͎ɌĂ΂)
 */
void FASTCALL mainetc_lp(void)
{
#if XM7_VER == 1
	/* }XNĂ΁AȂ */
	if (((fm_subtype == FMSUB_FM8) && !fm7irq_en) || lp_irq_mask) {
		return;
	}
#else
	/* }XNĂ΁AȂ */
	if (lp_irq_mask) {
		return;
	}
#endif

	/* CCPUIRQ荞݂ */
	lp_irq_flag = TRUE;

	/*  */
	maincpu_irq();
}

/*
 *	CCPU I/O
 *	PoCgǂݏo
 */
BOOL FASTCALL mainetc_readb(WORD addr, BYTE *dat)
{
	BYTE ret;

	switch (addr) {
		/* L[{[h  */
		case 0xfd00:
#if XM7_VER == 1
			if ((fm_subtype == FMSUB_FM8) && !keyport_en) {
				return FALSE;
			}
#endif

			if (key_fm7 & 0x0100) {
				ret = 0xff;
			}
			else {
				ret = 0x7f;
			}
#if XM7_VER == 1
			if (lowspeed_mode) {
				ret &= (BYTE)0xfe;
			}
#endif
			*dat = ret;
			return TRUE;

		/* L[{[h  */
		case 0xfd01:
#if XM7_VER == 1
			if ((fm_subtype == FMSUB_FM8) && !keyport_en) {
				return FALSE;
			}
#endif

			*dat = (BYTE)(key_fm7 & 0xff);
			key_irq_flag = FALSE;
			maincpu_irq();
			subcpu_firq();
			return TRUE;

		/* IRQv */
		case 0xfd03:
#if XM7_VER == 1
			if ((fm_subtype == FMSUB_FM8) && !fm7irq_en) {
				return FALSE;
			}
#endif

			ret = 0xff;
			if ((key_irq_flag) && !key_irq_mask) {
				ret &= ~0x01;
			}
			if (lp_irq_flag) {
				ret &= ~0x02;
				lp_irq_flag = FALSE;
			}
			if (timer_irq_flag) {
				ret &= ~0x04;
				timer_irq_flag = FALSE;
			}
			if (mfd_irq_flag ||
				txrdy_irq_flag ||
				rxrdy_irq_flag ||
				syndet_irq_flag ||
#if XM7_VER >= 3
				dma_irq_flag ||
#endif
#ifdef MOUSE
				ptm_irq_flag ||
#endif
				opn_irq_flag ||
				whg_irq_flag ||
				thg_irq_flag) {
				ret &= ~0x08;
			}
			*dat = ret;
			maincpu_irq();
			return TRUE;

		/* BASIC ROM */
		case 0xfd0b:
#if XM7_VER == 1
			if (fm_subtype != FMSUB_FM7) {
#else
			if (fm7_ver != 1) {
#endif
				return FALSE;
			}
		case 0xfd0f:
#if XM7_VER == 1
			if ((fm_subtype == FMSUB_FM8) &&
				((banksel_en == BANKSEL_DISABLE) ||
				 (banksel_en == BANKSEL_RAMFILE))) {
				return TRUE;
			}

			/* FM-7/77[hBASICu[gROMs͉Ȃ */
			if (new7_bootpatch && (fm_subtype != FMSUB_FM8) &&
				(boot_mode == BOOT_BASIC) && hotreset_flag &&
				((maincpu.pc >= 0xfe00) && (maincpu.pc <= 0xffdf))) {
				return TRUE;
			}
#endif
			basicrom_en = TRUE;

#if XM7_VER == 1
			/* FM-8[h̓u[g[h؂ւdl */
			if ((fm_subtype == FMSUB_FM8) &&
				(banksel_en == BANKSEL_ENABLE_DIPSW)) {
				boot_mode = BOOT_BASIC;
			}
#endif

			*dat = 0xff;
			return TRUE;

		/* g荞݃Xe[^X */
		case 0xfd17:
			*dat = 0xff;
#if XM7_VER >= 2
			if ((fm7_ver >= 2) &&
				(opn_timera_int[OPN_STD] || opn_timerb_int[OPN_STD])) {
				*dat &= (BYTE)~0x08;
			}
#endif
#ifdef MOUSE
			if (ptm_irq_flag) {
				*dat &= (BYTE)~0x04;
			}
#endif
			return TRUE;
	}

	return FALSE;
}

/*
 *	CCPU I/O
 *	PoCg
 */
BOOL FASTCALL mainetc_writeb(WORD addr, BYTE dat)
{
	switch (addr) {
		/* 荞݃}XN */
		case 0xfd02:
#if XM7_VER == 1
			if ((fm_subtype == FMSUB_FM8) && !fm7irq_en) {
				return FALSE;
			}
#endif

			if (dat & 0x80) {
				syndet_irq_mask = FALSE;
			}
			else {
				syndet_irq_mask = TRUE;
			}
			if (dat & 0x40) {
				rxrdy_irq_mask = FALSE;
			}
			else {
				rxrdy_irq_mask = TRUE;
			}
			if (dat & 0x20) {
				txrdy_irq_mask = FALSE;
			}
			else {
				txrdy_irq_mask = TRUE;
			}
			if (dat & 0x10) {
				mfd_irq_mask = FALSE;
			}
			else {
				mfd_irq_mask = TRUE;
			}
			if (dat & 0x04) {
				timer_irq_mask = FALSE;
			}
			else {
				timer_irq_mask = TRUE;
			}
			if (dat & 0x02) {
				lp_irq_mask = FALSE;
			}
			else {
				lp_irq_mask = TRUE;
			}
			if (dat & 0x01) {
				key_irq_mask = FALSE;
			}
			else {
				key_irq_mask = TRUE;
			}
			maincpu_irq();
			subcpu_firq();
			return TRUE;

		/* BEEP */
		case 0xfd03:
			/* Xs[JtȌ */
			if (dat & 0x01) {
				speaker_flag = TRUE;
			}
			else {
				speaker_flag = FALSE;
			}
			if (dat & 0x40) {
				/* PBEEP */
				beep_flag = TRUE;
				schedule_setevent(EVENT_BEEP, 205000, mainetc_beep);

				/* ʒm */
				beep_notify();
			}
			else {
				if (dat & 0x80) {
					/* ABEEP */
					beep_flag = TRUE;
				}
				else {
					/* BEEP OFF */
					beep_flag = FALSE;
				}

				/* ʒm */
				beep_notify();
			}
			return TRUE;

		/* AiO|[g/BASIC ROM(RAM FILE) */
#if XM7_VER == 1
		case 0xfd0c:
			if (fm_subtype != FMSUB_FM8) {
				return FALSE;
			}

			/* łBASIC ROM(RAM FILE)؂肩@\̂ */
			if (banksel_en == BANKSEL_RAMFILE) {
				/* bit6ɏ]ăoN(fBbvXCb`ݒ) */
				if (dat & 0x40) {
					/* RAM[h */
					boot_mode = BOOT_DOS;
					basicrom_en = FALSE;
				}
				else {
					/* BASIC ROM[h */
					boot_mode = boot_mode_reset;
					basicrom_en = TRUE;
				}
			}

			return TRUE;
#endif

		/* BASIC ROM */
		case 0xfd0b:
#if XM7_VER == 1
			if (fm_subtype != FMSUB_FM7) {
#else
			if (fm7_ver != 1) {
#endif
				return FALSE;
			}
		case 0xfd0f:
#if XM7_VER == 1
			if ((fm_subtype == FMSUB_FM8) &&
				((banksel_en == BANKSEL_DISABLE) ||
				 (banksel_en == BANKSEL_RAMFILE))) {
				return TRUE;
			}

			/* FM-7/77[hBASICu[gROMs͉Ȃ */
			if (new7_bootpatch && (fm_subtype != FMSUB_FM8) &&
				(boot_mode == BOOT_BASIC) && hotreset_flag &&
				((maincpu.pc >= 0xfe00) && (maincpu.pc <= 0xffdf))) {
				return TRUE;
			}
#endif
			basicrom_en = FALSE;

#if XM7_VER == 1
			/* FM-8[h̓u[g[h؂ւdl */
			if ((fm_subtype == FMSUB_FM8) &&
				(banksel_en == BANKSEL_ENABLE_DIPSW)) {
#ifdef BUBBLE
				if (boot_mode_reset == BOOT_BASIC) {
					boot_mode = BOOT_DOS;
				}
				else {
					boot_mode = boot_mode_reset;
				}
#else
				boot_mode = BOOT_DOS;
#endif
			}
#endif

			return TRUE;

		/* }EXZbg荞݃}XNWX^ */
		case 0xfd17:
#ifdef MOUSE
			if (dat & 0x04) {
				ptm_irq_mask = FALSE;
			}
			else {
				ptm_irq_mask = TRUE;
			}
#endif
			return TRUE;
	}

	return FALSE;
}

/*
 *	CCPU I/O
 *	Z[u
 */
BOOL FASTCALL mainetc_save(int fileh)
{
	if (!file_bool_write(fileh, key_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, key_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, lp_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, lp_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, timer_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, timer_irq_mask)) {
		return FALSE;
	}

	if (!file_bool_write(fileh, mfd_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, mfd_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, txrdy_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, txrdy_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, rxrdy_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, rxrdy_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, syndet_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, syndet_irq_mask)) {
		return FALSE;
	}
#ifdef MOUSE
	if (!file_bool_write(fileh, ptm_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, ptm_irq_mask)) {
		return FALSE;
	}
#endif
	if (!file_bool_write(fileh, opn_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, whg_irq_flag)) {
		return FALSE;
	}

	/* Ver6,8ǉ */
	if (!file_bool_write(fileh, thg_irq_flag)) {
		return FALSE;
	}
#if XM7_VER >= 3
	/* Ver8ǉ */
	if (!file_bool_write(fileh, dma_irq_flag)) {
		return FALSE;
	}
#endif

	if (!file_bool_write(fileh, beep_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, speaker_flag)) {
		return FALSE;
	}

#if XM7_VER == 1
	if (!file_byte_write(fileh, banksel_en)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, keyport_en)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, fm7irq_en)) {
		return FALSE;
	}
#endif

	return TRUE;
}

/*
 *	CCPU I/O
 *	[h
 */
BOOL FASTCALL mainetc_load(int fileh, int ver)
{
	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &key_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &key_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &lp_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &lp_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &timer_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &timer_irq_mask)) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &mfd_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &mfd_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &txrdy_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &txrdy_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &rxrdy_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &rxrdy_irq_mask)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &syndet_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &syndet_irq_mask)) {
		return FALSE;
	}

	/* Ver3.09/7.19/9.19ǉ */
#ifdef MOUSE
#if XM7_VER == 1
	if (ver >= 309) {
#elif XM7_VER == 2
	if ((ver >= 719) && (ver <= 799)) {
#else
	if (((ver >= 719) && (ver <= 799)) || (ver >= 919)) {
#endif
		if (!file_bool_read(fileh, &ptm_irq_flag)) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &ptm_irq_mask)) {
			return FALSE;
		}
	}
#endif

	if (!file_bool_read(fileh, &opn_irq_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &whg_irq_flag)) {
		return FALSE;
	}

	/* Ver6ǉ */
#if XM7_VER >= 2
	if (ver >= 600) {
#else
	if (ver >= 300) {
#endif
		if (!file_bool_read(fileh, &thg_irq_flag)) {
			return FALSE;
		}
	}

#if XM7_VER >= 3
	/* Ver8ǉ */
	if (ver >= 800) {
		if (!file_bool_read(fileh, &dma_irq_flag)) {
			return FALSE;
		}
	}
#endif

	if (!file_bool_read(fileh, &beep_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &speaker_flag)) {
		return FALSE;
	}

#if XM7_VER == 1
	/* Ver3.03g */
	if (ver >= 303) {
		if (!file_byte_read(fileh, &banksel_en)) {
			return FALSE;
		}
		if (banksel_en > BANKSEL_ENABLE_DIPSW) {
			banksel_en = BANKSEL_ENABLE;
		}
	}
	else {
		banksel_en = BANKSEL_DISABLE;
	}

	/* Ver3.14g */
	if (ver >= 314) {
		if (!file_bool_read(fileh, &keyport_en)) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &fm7irq_en)) {
			return FALSE;
		}
	}
	else {
		keyport_en = FALSE;
		fm7irq_en = FALSE;
	}
#endif

	/* Cxg */
	schedule_handle(EVENT_MAINTIMER, mainetc_event);
	schedule_handle(EVENT_BEEP, mainetc_beep);

	/* ʒm */
	beep_notify();

	return TRUE;
}
